/*

                 CDD  --  Change Drive and Directory

                          compiler: CI86

 A simple program to change both drive and file directory. I can think
 of several enhancements to this,  but this  serves my purpose well. I
 will leave improvements up to you.  Have fun...

                      By Bruce B. Thomson 8/86

                     May be distributed freely.

*/

struct regval  { 
	int ax, bx, cx, dx, si, di, ds, es; 
};
typedef struct regval REGVL;

struct segreg  { 
	int scs, sss, sds, ses; 
};
typedef struct segreg SEGRG;

main (argc, argv)
int     argc;
char   *argv[];
{
	unsigned int pitch;
	unsigned char kind, sleeptime;

#ifdef DEBUG
	int i;
	for(i=0; i < argc; i++)
		printf("argv[%d] = %s\n",i,argv[i]);
#endif

	if (argc < 2 || argc > 2)
	{
		printf ("\nCdd usage: cdd <path>\n");
		printf ("where <path> = drive:/sub-dir/././...\n");
	}
	/*
		SaveCurrent();  Later addition to make cdd with no args take us
		back....
	*/
	ChngDrv(argv[1]);
	if (!ChngDir(argv[1])) printf("\nPath not found\n");
}

ChngDrv(dr)
char *dr;
{
	char *dptr;
	dptr = dr;
	while (*dptr) {
		if (*dptr == ':') {
			dptr--;
			if ((Upper(*dptr) >= 'A') && (Upper(*dptr) <= 'Z')) {
				SelDsk((Upper(*dptr))-'A');
				return(1);
			}
			else return(0);
		}
		dptr++;
	}
	return(0);
}

ChngDir(dr)
char *dr;
{
	char *dptr;
	dptr = dr;
	while (*dptr) {
		if (*dptr == ':') {
			dptr++;
			return(SelDir(dptr));
		}
		dptr++;
	}
	return(SelDir(dr));
}

SelDir(dr)
char *dr;
{
	REGVL r;
	SEGRG sr;
	segread(&sr);
	r.ds = sr.sds;
	r.dx = dr;
	r.ax = 0x3b00;
	sysint21(&r,&r);
	if (r.ax == 3) return(0);
	else return(1);
}		

SelDsk(dr)
char dr;
{
	REGVL r;
	r.ax = 0x0e00;
	r.dx = dr;
	sysint21(&r,&r);
}

Upper(c)
register int c;
{
	return (islower(c) ? toupper(c) : c);
}

/* eof */
